// Based on:
//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// dll.cpp
//


#include "extdll.h"
#include "dllapi.h"
#include "h_export.h"
#include "meta_api.h"
#include "entity_state.h"
#include "pm_defs.h"



#include "bot.h"
#include "bot_func.h"
#include "pb_global.h"
#include "parabot.h"
#include "pb_chat.h"
#include "pb_mapcells.h"
#include "pb_configuration.h"


extern bool speechSynthesis;
//extern ChatList chatGotKilled, chatKilledPlayer, chatGotWeapon, chatReplyUnknown;
extern bot_t bots[32];
extern PB_Configuration pbConfig;
extern PB_Chat chat;
extern char g_argv[1024];

//#include "hl_game.h"
//extern HL_Game game;

int numberOfClients = 0;
edict_t *playerEnt = 0;
edict_t *clients[32];
DLL_FUNCTIONS other_gFunctionTable;
DLL_GLOBAL const Vector g_vecZero = Vector(0,0,0);
int isFakeClientCommand = 0;
int fake_arg_count;
float bot_check_time = 10.0;	// will be set to correct value when client connects
int min_bots = -1;					
bool g_GameRules = FALSE;		
int welcome_index = -1;	
int wpSpriteTexture, wpBeamTexture, wpSprite2Texture;
physent_t *ptrPhysents;
int numPhysents;


static FILE *fp;


void StartFrame( void );	// in startframe.cpp
void saveLevelData( void );	// in pb_mapimport.cpp
//void debugFile( char *msg );
void DSaddbot();
void DSsimulate();
void DSlogChat();
void DSrestrictedWeapons();
void DSpeace();



void GameDLLInit( void )
{
	(*g_engfuncs.pfnAddServerCommand)("addbot", DSaddbot );
	(*g_engfuncs.pfnAddServerCommand)("hidewelcome", DSsimulate );
	(*g_engfuncs.pfnAddServerCommand)("chatlog", DSlogChat );
	(*g_engfuncs.pfnAddServerCommand)("restrictedweapons", DSrestrictedWeapons );
	(*g_engfuncs.pfnAddServerCommand)("peacemode", DSpeace );

   for (int i=0; i<32; i++)
      clients[i] = NULL;
   
   // initialize the bots array of structures...
   memset(bots, 0, sizeof(bots));

   RETURN_META(MRES_IGNORED);
}

int DispatchSpawn( edict_t *pent )
{
   if (gpGlobals->deathmatch)
   {
      char *pClassname = (char *)STRING(pent->v.classname);

      if (strcmp(pClassname, "worldspawn") == 0)
      {
         // do level initialization stuff here...
/*
		  if (speechSynthesis) {
			  // precache samples
				int i;
				for (i=0; i<chatGotKilled.size(); i++ ) 
					PRECACHE_SOUND( chatGotKilled[i].text );
				for (i=0; i<chatKilledPlayer.size(); i++ ) 
					PRECACHE_SOUND( chatKilledPlayer[i].text );
				for (i=0; i<chatGotWeapon.size(); i++ ) 
					PRECACHE_SOUND( chatGotWeapon[i].text );
				for (i=0; i<chatReplyUnknown.size(); i++ ) 
					PRECACHE_SOUND( chatReplyUnknown[i].text );
		  }
*/
           PRECACHE_SOUND("weapons/xbow_hit1.wav");      // waypoint add
           PRECACHE_SOUND("weapons/mine_activate.wav");  // waypoint delete
           PRECACHE_SOUND("common/wpn_hudoff.wav");      // path add/delete start
           PRECACHE_SOUND("common/wpn_hudon.wav");       // path add/delete done
           PRECACHE_SOUND("common/wpn_moveselect.wav");  // path add/delete cancel
           PRECACHE_SOUND("common/wpn_denyselect.wav");  // path add/delete error
           wpBeamTexture = PRECACHE_MODEL( "sprites/lgtning.spr");
		   wpSpriteTexture = PRECACHE_MODEL( "sprites/hotglow.spr");
		   wpSprite2Texture = PRECACHE_MODEL( "sprites/laserdot.spr");

         g_GameRules = TRUE;
      }
//	  else if (strcmp(pClassname, "env_sound") == 0) debugMsg( "DISPATCH env_sound\n" );
//	  else if (strcmp(pClassname, "env_shake") == 0) debugMsg( "DISPATCH env_shake\n" );
//	  else if (strcmp(pClassname, "env_explosion") == 0) debugMsg( "DISPATCH env_explosion\n" );
   }

   RETURN_META_VALUE(MRES_IGNORED, 0);
}

///////////////////////////////////////////////////////////////////////////////////
//
//  CLIENT HANDLING
//
///////////////////////////////////////////////////////////////////////////////////


BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{ 
	char buffer[256];
	sprintf( buffer, "%.f: ClientConnect: %s (%s)", worldTime(), STRING(pEntity->v.netname), pszName );
	debugFile( buffer );
	
	if (gpGlobals->deathmatch)
	{
		// check if this client is the listen server client
		if (strcmp(pszAddress, "loopback") == 0)
		{
			// save the edict of the listen server client...
			playerEnt = pEntity;
		}
		// check if this is NOT a bot joining the server...
		if (strcmp(pszAddress, "127.0.0.1") != 0) {
			// don't try to add bots for 10 seconds, give client time to get added
			if (bot_check_time < gpGlobals->time + 10.0) bot_check_time = gpGlobals->time + 10.0;
		}
	}
	
	bool connected = MDLL_ClientConnect(pEntity, pszName, pszAddress, szRejectReason);

	debugFile( "  OK\n" );
	RETURN_META_VALUE(MRES_SUPERCEDE, connected);
}


void ClientDisconnect( edict_t *pEntity )
{
	int i, index = -1;
	char buffer[256];
	sprintf( buffer, "%.f: ClientDisconnect: %s ", worldTime(), STRING(pEntity->v.netname) );
	if (gpGlobals->deathmatch) {
		i = 0;
		while ((i < 32) && (clients[i] != pEntity))	i++;
		if (i < 32)	clients[i] = NULL;
		
		for (i=0; i < 32; i++) {
			if (bots[i].pEdict == pEntity) {
				index = i;
				break;
			}
		}
		
		if (index != -1) {	// bot is disconnecting
			debugMsg( "BOT DISCONNECT.\n" );
			strcat( buffer, "...freeing bot" );
			bots[index].is_used = FALSE;  // this slot is now free to use
			bots[index].pEdict = 0;
			pbConfig.personalityLeaves( bots[index].personality, worldTime() );
			delete (bots[index].parabot);	bots[index].parabot = 0;			
		}
	}
	debugFile( buffer );
	numberOfClients--;
	MDLL_ClientDisconnect(pEntity);

	debugFile( "  OK\n" );

	RETURN_META(MRES_SUPERCEDE);
}


void ClientPutInServer( edict_t *pEntity )
{
	int index = 0;
	while ((index < 32) && (clients[index] != NULL)) index++;
	if (index < 32) clients[index] = pEntity;
	else {
		FILE *dfp=fopen( "parabot/crashlog.txt", "a" ); 
		fprintf( dfp, "32 clients in ClientPutInServer()!\n" ); 
		fclose( dfp );
	}
	// check if this is NOT a bot joining the server...
	if (UTIL_GetBotIndex( pEntity ) == -1) {
		// next welcome message to this client:
		if (welcome_index == -1) welcome_index = index;
	}
	
	EHANDLE np;
	np.Set( pEntity );
	//HL_World *hlw = (HL_World*)game.world();
	//hlw->addPlayer( np );
	numberOfClients++;
	RETURN_META(MRES_IGNORED);
}

void ServerDeactivate( void )
{
   saveLevelData();		// save last level's data
   RETURN_META(MRES_IGNORED);
}

void PM_Move ( struct playermove_s *ppmove, int server )
{
	assert( ppmove != 0 );
	ptrPhysents = &(ppmove->visents[0]);
	numPhysents = ppmove->numvisent;
	
   RETURN_META(MRES_IGNORED);
}

C_DLLEXPORT int GetEntityAPI( DLL_FUNCTIONS *pFunctionTable, int interfaceVersion )
{
   memset(pFunctionTable, 0, sizeof(DLL_FUNCTIONS));

   pFunctionTable->pfnGameInit = GameDLLInit;
   pFunctionTable->pfnSpawn = DispatchSpawn;
   pFunctionTable->pfnClientConnect = ClientConnect;
   pFunctionTable->pfnClientDisconnect = ClientDisconnect;
   pFunctionTable->pfnClientPutInServer = ClientPutInServer;
   pFunctionTable->pfnServerDeactivate = ServerDeactivate;
   pFunctionTable->pfnPM_Move = PM_Move;
   pFunctionTable->pfnStartFrame = StartFrame;
   pFunctionTable->pfnClientCommand = ClientCommand;

   return TRUE;
}

void FakeClientCommand(edict_t *pBot, char *arg1, char *arg2, char *arg3)
{
   int length;

   isFakeClientCommand = 1;
   memset( &g_argv[0], 0, 256 );	// bugfix?

   if ((arg1 == NULL) || (*arg1 == 0)) return;

   if ((arg2 == NULL) || (*arg2 == 0))
   {
      length = sprintf(&g_argv[0], "%s", arg1);
      fake_arg_count = 1;
   }
   else if ((arg3 == NULL) || (*arg3 == 0))
   {
      length = sprintf(&g_argv[0], "%s %s", arg1, arg2);
      fake_arg_count = 2;
   }
   else
   {
      length = sprintf(&g_argv[0], "%s %s %s", arg1, arg2, arg3);
      fake_arg_count = 3;
   }

   g_argv[length] = 0;  // null terminate just in case

   strcpy(&g_argv[64], arg1);

   if (arg2)
      strcpy(&g_argv[128], arg2);

   if (arg3)
      strcpy(&g_argv[192], arg3);

   // allow the MOD DLL to execute the ClientCommand...
   MDLL_ClientCommand(pBot);

   isFakeClientCommand = 0;
}


const char *Cmd_Args( void )
{
   if (isFakeClientCommand)
   {
      RETURN_META_VALUE(MRES_SUPERCEDE, &g_argv[0]);
   }
   else
   {
      RETURN_META_VALUE(MRES_IGNORED, 0);
   }
}


const char *Cmd_Argv( int argc )
{
   if (isFakeClientCommand)
   {
      if (argc == 0)
      {
         RETURN_META_VALUE(MRES_SUPERCEDE, &g_argv[64]);
      }
      else if (argc == 1)
      {
         RETURN_META_VALUE(MRES_SUPERCEDE, &g_argv[128]);
      }
      else if (argc == 2)
      {
         RETURN_META_VALUE(MRES_SUPERCEDE, &g_argv[192]);
      }
      else
      {
         RETURN_META_VALUE(MRES_SUPERCEDE, "???");
      }
   }
   else
   {
      RETURN_META_VALUE(MRES_IGNORED, 0);
   }
}


int Cmd_Argc( void )
{
   if (isFakeClientCommand)
   {
      RETURN_META_VALUE(MRES_SUPERCEDE, fake_arg_count);
   }
   else
   {
      RETURN_META_VALUE(MRES_IGNORED, 0);
   }
}

