// Based on:
//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// engine.cpp
//

#include "extdll.h"
#include "dllapi.h"
#include "h_export.h"
#include "meta_api.h"
#include "entity_state.h"
#include "pb_global.h"
#include "sounds.h"

#include "bot.h"
#include "bot_client.h"

// HolyWars: gets modified in writeString
bool haloOnBase = true;

extern enginefuncs_t g_engfuncs;
extern bot_t bots[32];
extern int mod_id;
extern float roundStartTime;
extern Sounds playerSounds;

bool valveTeamPlayMode = false;
char valveTeamList[MAX_TEAMS][32] = { "","","","","","","","","","","","","","","","" };
int  valveTeamNumber = 0;

void (*botMsgFunction)(void *, int) = NULL;
int botMsgIndex;

// messages created in RegUserMsg which will be "caught"
int message_VGUI = 0;
int message_ShowMenu = 0;
int message_WeaponList = 0;
int message_CurWeapon = 0;
int message_AmmoX = 0;
int message_WeapPickup = 0;
int message_AmmoPickup = 0;
int message_ItemPickup = 0;
int message_Health = 0;
int message_Battery = 0;  // Armor
int message_Damage = 0;
int message_Death = 0;
int message_Money = 0;  // for Counter-Strike

static FILE *fp;



void pfnChangeLevel(char* s1, char* s2)
{
   // kick any bot off of the server after time/frag limit...
   for (int index = 0; index < 32; index++)
   {
      if (bots[index].is_used)  // is this slot used?
      {
         char cmd[40];

         sprintf(cmd, "kick \"%s\"\n", bots[index].name);

         bots[index].respawn_state = RESPAWN_NEED_TO_RESPAWN;
		 bots[index].is_used = false;

         SERVER_COMMAND(cmd);  // kick the bot using (kick "name")
      }
   }

   RETURN_META(MRES_IGNORED);
}


void pfnMessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *ed)
{
   if (gpGlobals->deathmatch)
   {
      int index = -1;

	  if (msg_type == message_Death) {
		  botMsgFunction = Client_Valve_DeathMsg;
	  }

      if (ed)
      {
         index = UTIL_GetBotIndex(ed);

         // is this message for a bot?
         if (index != -1)
         {
            botMsgFunction = NULL;  // no msg function until known otherwise
            botMsgIndex = index;    // index of bot receiving message

            switch( mod_id ) {
			case VALVE_DLL:
				if (msg_type == message_WeaponList)
					botMsgFunction = BotClient_Valve_WeaponList;
				else if (msg_type == message_CurWeapon)
					botMsgFunction = BotClient_Valve_CurrentWeapon;
				else if (msg_type == message_AmmoX)
					botMsgFunction = BotClient_Valve_AmmoX;
				else if (msg_type == message_AmmoPickup)
					botMsgFunction = BotClient_Valve_AmmoPickup;
				else if (msg_type == message_WeapPickup)
					botMsgFunction = BotClient_Valve_WeaponPickup;
				else if (msg_type == message_ItemPickup)
					botMsgFunction = BotClient_Valve_ItemPickup;
				else if (msg_type == message_Health)
					botMsgFunction = BotClient_Valve_Health;
				else if (msg_type == message_Battery)
					botMsgFunction = BotClient_Valve_Battery;
				else if (msg_type == message_Damage)
					botMsgFunction = BotClient_Valve_Damage;
				break;
            case HOLYWARS_DLL:
				if (msg_type == message_WeaponList)
					botMsgFunction = BotClient_Holywars_WeaponList;
				else if (msg_type == message_CurWeapon)
					botMsgFunction = BotClient_Holywars_CurrentWeapon;
				else if (msg_type == message_AmmoX)
					botMsgFunction = BotClient_Holywars_AmmoX;
				else if (msg_type == message_AmmoPickup)
					botMsgFunction = BotClient_Holywars_AmmoPickup;
				else if (msg_type == message_WeapPickup)
					botMsgFunction = BotClient_Holywars_WeaponPickup;
				else if (msg_type == message_ItemPickup)
					botMsgFunction = BotClient_Holywars_ItemPickup;
				else if (msg_type == message_Health)
					botMsgFunction = BotClient_Holywars_Health;
				else if (msg_type == message_Battery)
					botMsgFunction = BotClient_Holywars_Battery;
				else if (msg_type == message_Damage)
					botMsgFunction = BotClient_Holywars_Damage;
				break;
            case DMC_DLL:
				if (msg_type == message_WeaponList)
					botMsgFunction = BotClient_DMC_WeaponList;
				else if (msg_type == message_CurWeapon)
					botMsgFunction = BotClient_DMC_CurrentWeapon;
				else if (msg_type == message_AmmoX)
					botMsgFunction = BotClient_DMC_AmmoX;
				else if (msg_type == message_AmmoPickup)
					botMsgFunction = BotClient_DMC_AmmoPickup;
				else if (msg_type == message_WeapPickup)
					botMsgFunction = BotClient_DMC_WeaponPickup;
				else if (msg_type == message_ItemPickup)
					botMsgFunction = BotClient_DMC_ItemPickup;
				else if (msg_type == message_Health)
					botMsgFunction = BotClient_DMC_Health;
				else if (msg_type == message_Battery)
					botMsgFunction = BotClient_DMC_Battery;
				else if (msg_type == message_Damage)
					botMsgFunction = BotClient_DMC_Damage;
				break;
            case TFC_DLL:
				if (msg_type == message_VGUI)
					botMsgFunction = BotClient_TFC_VGUI;
				else if (msg_type == message_WeaponList)
					botMsgFunction = BotClient_TFC_WeaponList;
				else if (msg_type == message_CurWeapon)
					botMsgFunction = BotClient_TFC_CurrentWeapon;
				else if (msg_type == message_AmmoX)
					botMsgFunction = BotClient_TFC_AmmoX;
				else if (msg_type == message_AmmoPickup)
					botMsgFunction = BotClient_TFC_AmmoPickup;
				else if (msg_type == message_WeapPickup)
					botMsgFunction = BotClient_TFC_WeaponPickup;
				else if (msg_type == message_ItemPickup)
					botMsgFunction = BotClient_TFC_ItemPickup;
				else if (msg_type == message_Health)
					botMsgFunction = BotClient_TFC_Health;
				else if (msg_type == message_Battery)
					botMsgFunction = BotClient_TFC_Battery;
				else if (msg_type == message_Damage)
					botMsgFunction = BotClient_TFC_Damage;
				break;
            case CSTRIKE_DLL:
				if (msg_type == message_VGUI)
					botMsgFunction = BotClient_CS_VGUI;
				else if (msg_type == message_ShowMenu)
					botMsgFunction = BotClient_CS_ShowMenu;
				else if (msg_type == message_WeaponList)
					botMsgFunction = BotClient_CS_WeaponList;
				else if (msg_type == message_CurWeapon)
					botMsgFunction = BotClient_CS_CurrentWeapon;
				else if (msg_type == message_AmmoX) 
					botMsgFunction = BotClient_CS_AmmoX;
				else if (msg_type == message_WeapPickup)
					botMsgFunction = BotClient_CS_WeaponPickup;
				else if (msg_type == message_AmmoPickup)
					botMsgFunction = BotClient_CS_AmmoPickup;
				else if (msg_type == message_ItemPickup)
					botMsgFunction = BotClient_CS_ItemPickup;
				else if (msg_type == message_Health)
					botMsgFunction = BotClient_CS_Health;
				else if (msg_type == message_Battery)
					botMsgFunction = BotClient_CS_Battery;
				else if (msg_type == message_Damage)
					botMsgFunction = BotClient_CS_Damage;
				else if (msg_type == message_Money)
					botMsgFunction = BotClient_CS_Money;
				break;
			case GEARBOX_DLL:
				if (msg_type == message_WeaponList)
					botMsgFunction = BotClient_Gearbox_WeaponList;
				else if (msg_type == message_CurWeapon)
					botMsgFunction = BotClient_Gearbox_CurrentWeapon;
				else if (msg_type == message_AmmoX)
					botMsgFunction = BotClient_Gearbox_AmmoX;
				else if (msg_type == message_AmmoPickup)
					botMsgFunction = BotClient_Gearbox_AmmoPickup;
				else if (msg_type == message_WeapPickup)
					botMsgFunction = BotClient_Gearbox_WeaponPickup;
				else if (msg_type == message_ItemPickup)
					botMsgFunction = BotClient_Gearbox_ItemPickup;
				else if (msg_type == message_Health)
					botMsgFunction = BotClient_Gearbox_Health;
				else if (msg_type == message_Battery)
					botMsgFunction = BotClient_Gearbox_Battery;
				else if (msg_type == message_Damage)
					botMsgFunction = BotClient_Gearbox_Damage;
				break;
			}
         }
		 else {	// message for a human client
			if (msg_type == message_CurWeapon) {
				 botMsgIndex = ENTINDEX( ed );
				 botMsgFunction = HumanClient_CurrentWeapon;
			 }
		 }
      }
   }

   RETURN_META(MRES_IGNORED);
}


int pfnRegUserMsg(const char *pszName, int iSize)
{
	int msg = (*g_engfuncs.pfnRegUserMsg)(pszName, iSize);
	
	if (gpGlobals->deathmatch)
	{
		//fp=fopen("parabot\\debug.txt", "a"); fprintf(fp,"pfnRegUserMsg: pszName=%s msg=%d\n",pszName,msg); fclose(fp);

		if (strcmp( pszName, "WeaponList"	) == 0)	message_WeaponList = msg;
		else if (strcmp( pszName, "CurWeapon"	) == 0)	message_CurWeapon = msg;
		else if (strcmp( pszName, "AmmoX"       ) == 0)	message_AmmoX = msg;
		else if (strcmp( pszName, "AmmoPickup"  ) == 0)	message_AmmoPickup = msg;
		else if (strcmp( pszName, "WeapPickup"  ) == 0)	message_WeapPickup = msg;
		else if (strcmp( pszName, "ItemPickup"  ) == 0)	message_ItemPickup = msg;
		else if (strcmp( pszName, "Health"      ) == 0)	message_Health = msg;
		else if (strcmp( pszName, "Battery"     ) == 0)	message_Battery = msg;
		else if (strcmp( pszName, "Damage"      ) == 0)	message_Damage = msg;
		else if (strcmp( pszName, "DeathMsg"    ) == 0)	message_Death = msg;
		// TFC / CS
		else if (strcmp(pszName, "VGUIMenu"		) == 0) message_VGUI = msg;
		// CS only			
		else if (strcmp(pszName, "ShowMenu"		) == 0) message_ShowMenu = msg;
		else if (strcmp(pszName, "Money"		) == 0) message_Money = msg;         		
	}
	
	RETURN_META_VALUE(MRES_SUPERCEDE, msg);
}


void pfnMessageEnd(void)
{
   if (gpGlobals->deathmatch)
   {
      // clear out the bot message function pointer...
      botMsgFunction = NULL;
   }

   RETURN_META(MRES_IGNORED);
}

edict_t* pfnFindEntityByString(edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue)
{
	if (( mod_id == CSTRIKE_DLL ) &&
		( strcmp( pszField, "classname" ) == 0 ) && 
		( strcmp( pszValue, "info_map_parameters" ) == 0 ) ) {
		//debugMsg( "NEW CS-ROUND!\n" );
		roundStartTime = worldTime() + CVAR_GET_FLOAT("mp_freezetime");	// 5 seconds until round starts
	}
	RETURN_META_VALUE(MRES_IGNORED, 0);
}

void pfnEmitSound(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch)
{
	playerSounds.parseSound( entity, sample, volume );
	RETURN_META(MRES_IGNORED);
}

void pfnEmitAmbientSound(edict_t *entity, float *pos, const char *samp, float vol, float attenuation, int fFlags, int pitch)
{
	playerSounds.parseAmbientSound( entity, samp, vol );
	RETURN_META(MRES_IGNORED);
}

void pfnServerCommand(char* str)
{
	infoMsg( "ServerCommand: ", str, "\n" );
    RETURN_META(MRES_IGNORED);
}

void pfnClientCommand(edict_t* pEdict, char* szFmt, ...)
{
   if (!(pEdict->v.flags & FL_FAKECLIENT))
       RETURN_META(MRES_IGNORED);
   RETURN_META(MRES_SUPERCEDE);
}

void pfnWriteByte(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteChar(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteShort(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteLong(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteAngle(float flValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&flValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteCoord(float flValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&flValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteString(const char *sz)
{
   if (gpGlobals->deathmatch)
   {
	   if (mod_id==HOLYWARS_DLL) {
		   if ( strncmp(sz, "The halo disappeared", 10)==0 ) {
			   //debugMsg( "HALO ON BASE!\n" );
			   haloOnBase = true;
		   }
		   else if ( strncmp(sz, "We've got a new saint", 3)==0 ) {
			   //debugMsg( "HALO NOT ON BASE!\n" );
			   haloOnBase = false;
		   }
	   }

      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)sz, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}

void pfnWriteEntity(int iValue)
{
   if (gpGlobals->deathmatch)
   {
      // if this message is for a bot, call the client message function...
      if (botMsgFunction)
         (*botMsgFunction)((void *)&iValue, botMsgIndex);
   }

   RETURN_META(MRES_IGNORED);
}


void pfnSetClientKeyValue( int clientIndex, char *infobuffer, char *key, char *value )
{
	if ((mod_id == VALVE_DLL || mod_id == GEARBOX_DLL) && (strcmp( key, "team" ) == 0)) {	// init teamlist
		valveTeamPlayMode = true;

		bool teamKnown = false;
		for (int team=0; team<valveTeamNumber; team++) 
			if (strcmp( value, valveTeamList[team] ) == 0) {
				teamKnown = true;
				break;
			}
		if (!teamKnown && valveTeamNumber<MAX_TEAMS) {
			strcpy( valveTeamList[valveTeamNumber], value );
			debugMsg( "Registered team ", value, "\n" );
			valveTeamNumber++;
		}
	}
	RETURN_META(MRES_IGNORED);
}

C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion)
{
   pengfuncsFromEngine->pfnCmd_Argc = Cmd_Argc;
   pengfuncsFromEngine->pfnCmd_Argv = Cmd_Argv;
   pengfuncsFromEngine->pfnCmd_Args = Cmd_Args;
   pengfuncsFromEngine->pfnChangeLevel = pfnChangeLevel;
   pengfuncsFromEngine->pfnMessageBegin = pfnMessageBegin;
   pengfuncsFromEngine->pfnRegUserMsg = pfnRegUserMsg;
   pengfuncsFromEngine->pfnMessageEnd = pfnMessageEnd;
   pengfuncsFromEngine->pfnFindEntityByString = pfnFindEntityByString;
   pengfuncsFromEngine->pfnEmitSound = pfnEmitSound;
   pengfuncsFromEngine->pfnEmitAmbientSound = pfnEmitAmbientSound;
   pengfuncsFromEngine->pfnServerCommand = pfnServerCommand;
   pengfuncsFromEngine->pfnClientCommand = pfnClientCommand;
   pengfuncsFromEngine->pfnWriteByte = pfnWriteByte;
   pengfuncsFromEngine->pfnWriteChar = pfnWriteChar;
   pengfuncsFromEngine->pfnWriteShort = pfnWriteShort;
   pengfuncsFromEngine->pfnWriteLong = pfnWriteLong;
   pengfuncsFromEngine->pfnWriteAngle = pfnWriteAngle;
   pengfuncsFromEngine->pfnWriteCoord = pfnWriteCoord;
   pengfuncsFromEngine->pfnWriteString = pfnWriteString;
   pengfuncsFromEngine->pfnWriteEntity = pfnWriteEntity;
   pengfuncsFromEngine->pfnSetClientKeyValue = pfnSetClientKeyValue;

   return TRUE;
}

