// Based on:
//
// HPB bot - botman's High Ping Bastard bot
//
// (http://planethalflife.com/botman/)
//
// h_export.cpp
//

#include "extdll.h"
#include "dllapi.h"
#include "h_export.h"
#include "meta_api.h"
#include "entity_state.h"

#include "bot.h"
#include "pb_global.h"
#include "pb_configuration.h"
#include "pb_chat.h"

extern int mod_id;
PB_Configuration pbConfig;
PB_Chat chat;

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;
char g_argv[1024];

float sineTable[256];					// sine table for e.g. look-arounds

void initSineTable()
{
	for (int i=0; i<256; i++) {
		float f = (float) i;
		f *= 2*3.1415927/256;
		sineTable[i] = sin( f );
	}
}

// Required DLL entry point
C_DLLEXPORT BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
	}
	else if (fdwReason == DLL_PROCESS_DETACH)
	{
		chat.free();
/*
		// try to close ole
		gpITTSCentral->Release();
		
		if (!EndOLE())
			errorMsg( "Can't shut down OLE." );*/
	}
	
	return TRUE;
}

C_DLLEXPORT void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	char game_dir[256];
	char mod_name[32];

	// get the engine functions from the engine...
	memcpy( &g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t) );
	gpGlobals = pGlobals;

	// find the directory name of the currently running MOD...
	(*g_engfuncs.pfnGetGameDir)( game_dir );

	int pos = strlen( game_dir ) - 1;

	// scan backwards till first directory separator...
	while ((pos > 0) && (game_dir[pos] != '/')) pos--;
	if (pos != 0) pos++;
	strcpy( mod_name, &game_dir[pos] );

	if (stricmp(mod_name, "valve") == 0)
	{
		mod_id = VALVE_DLL;
		pbConfig.initConfiguration( "parabot/valve/parabot.cfg" );
		pbConfig.initPersonalities( "parabot/valve/characters.cfg" );
	}
	else if (stricmp(mod_name, "hldm") == 0)
	{
		mod_id = VALVE_DLL;
		pbConfig.initConfiguration( "parabot/valve/parabot.cfg" );
		pbConfig.initPersonalities( "parabot/valve/characters.cfg" );
	}
	else if (stricmp(mod_name, "holywars") == 0)
	{
		mod_id = HOLYWARS_DLL;
		pbConfig.initConfiguration( "parabot/holywars/parabot.cfg" );
		pbConfig.initPersonalities( "parabot/holywars/characters.cfg" );
	}
	else if (stricmp(mod_name, "dmc") == 0)
	{
		mod_id = DMC_DLL;
		pbConfig.initConfiguration( "parabot/dmc/parabot.cfg" );
		pbConfig.initPersonalities( "parabot/dmc/characters.cfg" );
	}
	else if (stricmp(mod_name, "gearbox") == 0)
	{
		mod_id = GEARBOX_DLL;
		pbConfig.initConfiguration( "parabot/gearbox/parabot.cfg" );
		pbConfig.initPersonalities( "parabot/gearbox/characters.cfg" );
	}

	// always load chatfile, might be enabled ingame:
	char chatFile[256];
	strcpy( chatFile, "parabot/" );
	strcat( chatFile, pbConfig.chatFile() );
	chat.load( chatFile );

	initSineTable();
}

